/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceProvidingEntity;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Black Box Behavior</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BlackBoxBehavior#getDescribedEntity <em>Described Entity</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BlackBoxBehavior#getResponseTime <em>Response Time</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage#getBlackBoxBehavior()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='AtMostOneBlackBoxBehaviorPerProvidedService'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot AtMostOneBlackBoxBehaviorPerProvidedService='\n\t\t\tself.describedEntity.blackBoxBehavior->forAll(bb1 : BlackBoxBehavior | bb1.describedSignature = self.describedSignature implies bb1 = self)'"
 * @generated
 */
public interface BlackBoxBehavior extends ServiceBehaviorAbstraction {
	/**
	 * Returns the value of the '<em><b>Described Entity</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Described Entity</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Described Entity</em>' reference.
	 * @see #setDescribedEntity(InterfaceProvidingEntity)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage#getBlackBoxBehavior_DescribedEntity()
	 * @model required="true"
	 * @generated
	 */
	InterfaceProvidingEntity getDescribedEntity();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BlackBoxBehavior#getDescribedEntity <em>Described Entity</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Described Entity</em>' reference.
	 * @see #getDescribedEntity()
	 * @generated
	 */
	void setDescribedEntity(InterfaceProvidingEntity value);

	/**
	 * Returns the value of the '<em><b>Response Time</b></em>' containment reference.
	 * It is bidirectional and its opposite is '{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ResponseTime#getBlackBoxBehavior <em>Black Box Behavior</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Response Time</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Response Time</em>' containment reference.
	 * @see #setResponseTime(ResponseTime)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage#getBlackBoxBehavior_ResponseTime()
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ResponseTime#getBlackBoxBehavior
	 * @model opposite="blackBoxBehavior" containment="true"
	 * @generated
	 */
	ResponseTime getResponseTime();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BlackBoxBehavior#getResponseTime <em>Response Time</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Response Time</em>' containment reference.
	 * @see #getResponseTime()
	 * @generated
	 */
	void setResponseTime(ResponseTime value);

} // BlackBoxBehavior
