/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior;

import edu.kit.ipd.descartes.mm.applicationlevel.functions.ExplicitDescription;

import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariable;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Response Time</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ResponseTime#getBlackBoxBehavior <em>Black Box Behavior</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ResponseTime#getCharacterization <em>Characterization</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ResponseTime#getExplicitDescription <em>Explicit Description</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage#getResponseTime()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='EnforceExplicitDescriptionWhenExplicitCharacterizationType'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot EnforceExplicitDescriptionWhenExplicitCharacterizationType='\n\t\t\tself.characterization = parameterdependencies::RelationshipCharacterizationType::EXPLICIT implies explicitDescription <> null'"
 * @generated
 */
public interface ResponseTime extends ModelVariable {
	/**
	 * Returns the value of the '<em><b>Black Box Behavior</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BlackBoxBehavior#getResponseTime <em>Response Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Black Box Behavior</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Black Box Behavior</em>' container reference.
	 * @see #setBlackBoxBehavior(BlackBoxBehavior)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage#getResponseTime_BlackBoxBehavior()
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BlackBoxBehavior#getResponseTime
	 * @model opposite="responseTime" required="true" transient="false"
	 * @generated
	 */
	BlackBoxBehavior getBlackBoxBehavior();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ResponseTime#getBlackBoxBehavior <em>Black Box Behavior</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Black Box Behavior</em>' container reference.
	 * @see #getBlackBoxBehavior()
	 * @generated
	 */
	void setBlackBoxBehavior(BlackBoxBehavior value);

	/**
	 * Returns the value of the '<em><b>Characterization</b></em>' attribute.
	 * The literals are from the enumeration {@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Characterization</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Characterization</em>' attribute.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType
	 * @see #setCharacterization(ModelVariableCharacterizationType)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage#getResponseTime_Characterization()
	 * @model required="true"
	 * @generated
	 */
	ModelVariableCharacterizationType getCharacterization();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ResponseTime#getCharacterization <em>Characterization</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Characterization</em>' attribute.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType
	 * @see #getCharacterization()
	 * @generated
	 */
	void setCharacterization(ModelVariableCharacterizationType value);

	/**
	 * Returns the value of the '<em><b>Explicit Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Explicit Description</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Explicit Description</em>' containment reference.
	 * @see #setExplicitDescription(ExplicitDescription)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage#getResponseTime_ExplicitDescription()
	 * @model containment="true"
	 * @generated
	 */
	ExplicitDescription getExplicitDescription();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ResponseTime#getExplicitDescription <em>Explicit Description</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Explicit Description</em>' containment reference.
	 * @see #getExplicitDescription()
	 * @generated
	 */
	void setExplicitDescription(ExplicitDescription value);

} // ResponseTime
