/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceProvidingEntity;

import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BlackBoxBehavior;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ResponseTime;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Black Box Behavior</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.BlackBoxBehaviorImpl#getDescribedEntity <em>Described Entity</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.BlackBoxBehaviorImpl#getResponseTime <em>Response Time</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class BlackBoxBehaviorImpl extends ServiceBehaviorAbstractionImpl implements BlackBoxBehavior {
	/**
	 * The cached value of the '{@link #getDescribedEntity() <em>Described Entity</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescribedEntity()
	 * @generated
	 * @ordered
	 */
	protected InterfaceProvidingEntity describedEntity;

	/**
	 * The cached value of the '{@link #getResponseTime() <em>Response Time</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getResponseTime()
	 * @generated
	 * @ordered
	 */
	protected ResponseTime responseTime;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BlackBoxBehaviorImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServicebehaviorPackage.Literals.BLACK_BOX_BEHAVIOR;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceProvidingEntity getDescribedEntity() {
		if (describedEntity != null && describedEntity.eIsProxy()) {
			InternalEObject oldDescribedEntity = (InternalEObject)describedEntity;
			describedEntity = (InterfaceProvidingEntity)eResolveProxy(oldDescribedEntity);
			if (describedEntity != oldDescribedEntity) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ServicebehaviorPackage.BLACK_BOX_BEHAVIOR__DESCRIBED_ENTITY, oldDescribedEntity, describedEntity));
			}
		}
		return describedEntity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceProvidingEntity basicGetDescribedEntity() {
		return describedEntity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescribedEntity(InterfaceProvidingEntity newDescribedEntity) {
		InterfaceProvidingEntity oldDescribedEntity = describedEntity;
		describedEntity = newDescribedEntity;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.BLACK_BOX_BEHAVIOR__DESCRIBED_ENTITY, oldDescribedEntity, describedEntity));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResponseTime getResponseTime() {
		return responseTime;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetResponseTime(ResponseTime newResponseTime, NotificationChain msgs) {
		ResponseTime oldResponseTime = responseTime;
		responseTime = newResponseTime;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.BLACK_BOX_BEHAVIOR__RESPONSE_TIME, oldResponseTime, newResponseTime);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setResponseTime(ResponseTime newResponseTime) {
		if (newResponseTime != responseTime) {
			NotificationChain msgs = null;
			if (responseTime != null)
				msgs = ((InternalEObject)responseTime).eInverseRemove(this, ServicebehaviorPackage.RESPONSE_TIME__BLACK_BOX_BEHAVIOR, ResponseTime.class, msgs);
			if (newResponseTime != null)
				msgs = ((InternalEObject)newResponseTime).eInverseAdd(this, ServicebehaviorPackage.RESPONSE_TIME__BLACK_BOX_BEHAVIOR, ResponseTime.class, msgs);
			msgs = basicSetResponseTime(newResponseTime, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.BLACK_BOX_BEHAVIOR__RESPONSE_TIME, newResponseTime, newResponseTime));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServicebehaviorPackage.BLACK_BOX_BEHAVIOR__RESPONSE_TIME:
				if (responseTime != null)
					msgs = ((InternalEObject)responseTime).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ServicebehaviorPackage.BLACK_BOX_BEHAVIOR__RESPONSE_TIME, null, msgs);
				return basicSetResponseTime((ResponseTime)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServicebehaviorPackage.BLACK_BOX_BEHAVIOR__RESPONSE_TIME:
				return basicSetResponseTime(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServicebehaviorPackage.BLACK_BOX_BEHAVIOR__DESCRIBED_ENTITY:
				if (resolve) return getDescribedEntity();
				return basicGetDescribedEntity();
			case ServicebehaviorPackage.BLACK_BOX_BEHAVIOR__RESPONSE_TIME:
				return getResponseTime();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ServicebehaviorPackage.BLACK_BOX_BEHAVIOR__DESCRIBED_ENTITY:
				setDescribedEntity((InterfaceProvidingEntity)newValue);
				return;
			case ServicebehaviorPackage.BLACK_BOX_BEHAVIOR__RESPONSE_TIME:
				setResponseTime((ResponseTime)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.BLACK_BOX_BEHAVIOR__DESCRIBED_ENTITY:
				setDescribedEntity((InterfaceProvidingEntity)null);
				return;
			case ServicebehaviorPackage.BLACK_BOX_BEHAVIOR__RESPONSE_TIME:
				setResponseTime((ResponseTime)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.BLACK_BOX_BEHAVIOR__DESCRIBED_ENTITY:
				return describedEntity != null;
			case ServicebehaviorPackage.BLACK_BOX_BEHAVIOR__RESPONSE_TIME:
				return responseTime != null;
		}
		return super.eIsSet(featureID);
	}

} //BlackBoxBehaviorImpl
