/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.functions.ExplicitDescription;

import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType;

import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ModelVariableImpl;

import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.CoarseGrainedBehavior;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.InternalAction;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ResourceDemand;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage;

import edu.kit.ipd.descartes.mm.resourcetype.ResourceType;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EcoreUtil;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Resource Demand</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.ResourceDemandImpl#getInternalAction <em>Internal Action</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.ResourceDemandImpl#getCoarseGrainedBehavior <em>Coarse Grained Behavior</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.ResourceDemandImpl#getResourceType <em>Resource Type</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.ResourceDemandImpl#getCharacterization <em>Characterization</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.ResourceDemandImpl#getExplicitDescription <em>Explicit Description</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ResourceDemandImpl extends ModelVariableImpl implements ResourceDemand {
	/**
	 * The cached value of the '{@link #getResourceType() <em>Resource Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getResourceType()
	 * @generated
	 * @ordered
	 */
	protected ResourceType resourceType;

	/**
	 * The default value of the '{@link #getCharacterization() <em>Characterization</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCharacterization()
	 * @generated
	 * @ordered
	 */
	protected static final ModelVariableCharacterizationType CHARACTERIZATION_EDEFAULT = ModelVariableCharacterizationType.EMPIRICAL;

	/**
	 * The cached value of the '{@link #getCharacterization() <em>Characterization</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCharacterization()
	 * @generated
	 * @ordered
	 */
	protected ModelVariableCharacterizationType characterization = CHARACTERIZATION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getExplicitDescription() <em>Explicit Description</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExplicitDescription()
	 * @generated
	 * @ordered
	 */
	protected ExplicitDescription explicitDescription;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ResourceDemandImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServicebehaviorPackage.Literals.RESOURCE_DEMAND;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InternalAction getInternalAction() {
		if (eContainerFeatureID() != ServicebehaviorPackage.RESOURCE_DEMAND__INTERNAL_ACTION) return null;
		return (InternalAction)eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetInternalAction(InternalAction newInternalAction, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newInternalAction, ServicebehaviorPackage.RESOURCE_DEMAND__INTERNAL_ACTION, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInternalAction(InternalAction newInternalAction) {
		if (newInternalAction != eInternalContainer() || (eContainerFeatureID() != ServicebehaviorPackage.RESOURCE_DEMAND__INTERNAL_ACTION && newInternalAction != null)) {
			if (EcoreUtil.isAncestor(this, newInternalAction))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newInternalAction != null)
				msgs = ((InternalEObject)newInternalAction).eInverseAdd(this, ServicebehaviorPackage.INTERNAL_ACTION__RESOURCE_DEMAND, InternalAction.class, msgs);
			msgs = basicSetInternalAction(newInternalAction, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.RESOURCE_DEMAND__INTERNAL_ACTION, newInternalAction, newInternalAction));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CoarseGrainedBehavior getCoarseGrainedBehavior() {
		if (eContainerFeatureID() != ServicebehaviorPackage.RESOURCE_DEMAND__COARSE_GRAINED_BEHAVIOR) return null;
		return (CoarseGrainedBehavior)eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCoarseGrainedBehavior(CoarseGrainedBehavior newCoarseGrainedBehavior, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newCoarseGrainedBehavior, ServicebehaviorPackage.RESOURCE_DEMAND__COARSE_GRAINED_BEHAVIOR, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCoarseGrainedBehavior(CoarseGrainedBehavior newCoarseGrainedBehavior) {
		if (newCoarseGrainedBehavior != eInternalContainer() || (eContainerFeatureID() != ServicebehaviorPackage.RESOURCE_DEMAND__COARSE_GRAINED_BEHAVIOR && newCoarseGrainedBehavior != null)) {
			if (EcoreUtil.isAncestor(this, newCoarseGrainedBehavior))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newCoarseGrainedBehavior != null)
				msgs = ((InternalEObject)newCoarseGrainedBehavior).eInverseAdd(this, ServicebehaviorPackage.COARSE_GRAINED_BEHAVIOR__RESOURCE_DEMAND, CoarseGrainedBehavior.class, msgs);
			msgs = basicSetCoarseGrainedBehavior(newCoarseGrainedBehavior, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.RESOURCE_DEMAND__COARSE_GRAINED_BEHAVIOR, newCoarseGrainedBehavior, newCoarseGrainedBehavior));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResourceType getResourceType() {
		if (resourceType != null && resourceType.eIsProxy()) {
			InternalEObject oldResourceType = (InternalEObject)resourceType;
			resourceType = (ResourceType)eResolveProxy(oldResourceType);
			if (resourceType != oldResourceType) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ServicebehaviorPackage.RESOURCE_DEMAND__RESOURCE_TYPE, oldResourceType, resourceType));
			}
		}
		return resourceType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResourceType basicGetResourceType() {
		return resourceType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setResourceType(ResourceType newResourceType) {
		ResourceType oldResourceType = resourceType;
		resourceType = newResourceType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.RESOURCE_DEMAND__RESOURCE_TYPE, oldResourceType, resourceType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModelVariableCharacterizationType getCharacterization() {
		return characterization;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCharacterization(ModelVariableCharacterizationType newCharacterization) {
		ModelVariableCharacterizationType oldCharacterization = characterization;
		characterization = newCharacterization == null ? CHARACTERIZATION_EDEFAULT : newCharacterization;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.RESOURCE_DEMAND__CHARACTERIZATION, oldCharacterization, characterization));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExplicitDescription getExplicitDescription() {
		return explicitDescription;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetExplicitDescription(ExplicitDescription newExplicitDescription, NotificationChain msgs) {
		ExplicitDescription oldExplicitDescription = explicitDescription;
		explicitDescription = newExplicitDescription;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.RESOURCE_DEMAND__EXPLICIT_DESCRIPTION, oldExplicitDescription, newExplicitDescription);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setExplicitDescription(ExplicitDescription newExplicitDescription) {
		if (newExplicitDescription != explicitDescription) {
			NotificationChain msgs = null;
			if (explicitDescription != null)
				msgs = ((InternalEObject)explicitDescription).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ServicebehaviorPackage.RESOURCE_DEMAND__EXPLICIT_DESCRIPTION, null, msgs);
			if (newExplicitDescription != null)
				msgs = ((InternalEObject)newExplicitDescription).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ServicebehaviorPackage.RESOURCE_DEMAND__EXPLICIT_DESCRIPTION, null, msgs);
			msgs = basicSetExplicitDescription(newExplicitDescription, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.RESOURCE_DEMAND__EXPLICIT_DESCRIPTION, newExplicitDescription, newExplicitDescription));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServicebehaviorPackage.RESOURCE_DEMAND__INTERNAL_ACTION:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetInternalAction((InternalAction)otherEnd, msgs);
			case ServicebehaviorPackage.RESOURCE_DEMAND__COARSE_GRAINED_BEHAVIOR:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetCoarseGrainedBehavior((CoarseGrainedBehavior)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServicebehaviorPackage.RESOURCE_DEMAND__INTERNAL_ACTION:
				return basicSetInternalAction(null, msgs);
			case ServicebehaviorPackage.RESOURCE_DEMAND__COARSE_GRAINED_BEHAVIOR:
				return basicSetCoarseGrainedBehavior(null, msgs);
			case ServicebehaviorPackage.RESOURCE_DEMAND__EXPLICIT_DESCRIPTION:
				return basicSetExplicitDescription(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case ServicebehaviorPackage.RESOURCE_DEMAND__INTERNAL_ACTION:
				return eInternalContainer().eInverseRemove(this, ServicebehaviorPackage.INTERNAL_ACTION__RESOURCE_DEMAND, InternalAction.class, msgs);
			case ServicebehaviorPackage.RESOURCE_DEMAND__COARSE_GRAINED_BEHAVIOR:
				return eInternalContainer().eInverseRemove(this, ServicebehaviorPackage.COARSE_GRAINED_BEHAVIOR__RESOURCE_DEMAND, CoarseGrainedBehavior.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServicebehaviorPackage.RESOURCE_DEMAND__INTERNAL_ACTION:
				return getInternalAction();
			case ServicebehaviorPackage.RESOURCE_DEMAND__COARSE_GRAINED_BEHAVIOR:
				return getCoarseGrainedBehavior();
			case ServicebehaviorPackage.RESOURCE_DEMAND__RESOURCE_TYPE:
				if (resolve) return getResourceType();
				return basicGetResourceType();
			case ServicebehaviorPackage.RESOURCE_DEMAND__CHARACTERIZATION:
				return getCharacterization();
			case ServicebehaviorPackage.RESOURCE_DEMAND__EXPLICIT_DESCRIPTION:
				return getExplicitDescription();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ServicebehaviorPackage.RESOURCE_DEMAND__INTERNAL_ACTION:
				setInternalAction((InternalAction)newValue);
				return;
			case ServicebehaviorPackage.RESOURCE_DEMAND__COARSE_GRAINED_BEHAVIOR:
				setCoarseGrainedBehavior((CoarseGrainedBehavior)newValue);
				return;
			case ServicebehaviorPackage.RESOURCE_DEMAND__RESOURCE_TYPE:
				setResourceType((ResourceType)newValue);
				return;
			case ServicebehaviorPackage.RESOURCE_DEMAND__CHARACTERIZATION:
				setCharacterization((ModelVariableCharacterizationType)newValue);
				return;
			case ServicebehaviorPackage.RESOURCE_DEMAND__EXPLICIT_DESCRIPTION:
				setExplicitDescription((ExplicitDescription)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.RESOURCE_DEMAND__INTERNAL_ACTION:
				setInternalAction((InternalAction)null);
				return;
			case ServicebehaviorPackage.RESOURCE_DEMAND__COARSE_GRAINED_BEHAVIOR:
				setCoarseGrainedBehavior((CoarseGrainedBehavior)null);
				return;
			case ServicebehaviorPackage.RESOURCE_DEMAND__RESOURCE_TYPE:
				setResourceType((ResourceType)null);
				return;
			case ServicebehaviorPackage.RESOURCE_DEMAND__CHARACTERIZATION:
				setCharacterization(CHARACTERIZATION_EDEFAULT);
				return;
			case ServicebehaviorPackage.RESOURCE_DEMAND__EXPLICIT_DESCRIPTION:
				setExplicitDescription((ExplicitDescription)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.RESOURCE_DEMAND__INTERNAL_ACTION:
				return getInternalAction() != null;
			case ServicebehaviorPackage.RESOURCE_DEMAND__COARSE_GRAINED_BEHAVIOR:
				return getCoarseGrainedBehavior() != null;
			case ServicebehaviorPackage.RESOURCE_DEMAND__RESOURCE_TYPE:
				return resourceType != null;
			case ServicebehaviorPackage.RESOURCE_DEMAND__CHARACTERIZATION:
				return characterization != CHARACTERIZATION_EDEFAULT;
			case ServicebehaviorPackage.RESOURCE_DEMAND__EXPLICIT_DESCRIPTION:
				return explicitDescription != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (characterization: ");
		result.append(characterization);
		result.append(')');
		return result.toString();
	}

} //ResourceDemandImpl
