/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.functions.FunctionsPackage;

import edu.kit.ipd.descartes.mm.applicationlevel.functions.impl.FunctionsPackageImpl;

import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage;

import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.RepositoryPackageImpl;

import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.AbstractAction;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.AcquireAction;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BlackBoxBehavior;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BranchAction;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BranchProbabilities;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.CallFrequency;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.CoarseGrainedBehavior;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ComponentInternalBehavior;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ExternalCall;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ExternalCallAction;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ExternalCallFrequency;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.FineGrainedBehavior;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ForkAction;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.InternalAction;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.LoopAction;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.LoopIterationCount;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ReleaseAction;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ResourceDemand;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ResponseTime;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServiceBehaviorAbstraction;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorFactory;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage;

import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.util.ServicebehaviorValidator;

import edu.kit.ipd.descartes.mm.applicationlevel.system.SystemPackage;

import edu.kit.ipd.descartes.mm.applicationlevel.system.impl.SystemPackageImpl;

import edu.kit.ipd.descartes.mm.resourcetype.ResourcetypePackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EValidator;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ServicebehaviorPackageImpl extends EPackageImpl implements ServicebehaviorPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass serviceBehaviorAbstractionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass fineGrainedBehaviorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass componentInternalBehaviorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass abstractActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass acquireActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass releaseActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass internalActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass forkActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass branchActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass branchProbabilitiesEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass loopActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass loopIterationCountEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass externalCallActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass externalCallEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass resourceDemandEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass coarseGrainedBehaviorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass externalCallFrequencyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass callFrequencyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass blackBoxBehaviorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass responseTimeEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private ServicebehaviorPackageImpl() {
		super(eNS_URI, ServicebehaviorFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link ServicebehaviorPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static ServicebehaviorPackage init() {
		if (isInited) return (ServicebehaviorPackage)EPackage.Registry.INSTANCE.getEPackage(ServicebehaviorPackage.eNS_URI);

		// Obtain or create and register package
		ServicebehaviorPackageImpl theServicebehaviorPackage = (ServicebehaviorPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof ServicebehaviorPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new ServicebehaviorPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		ResourcetypePackage.eINSTANCE.eClass();

		// Obtain or create and register interdependencies
		FunctionsPackageImpl theFunctionsPackage = (FunctionsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FunctionsPackage.eNS_URI) instanceof FunctionsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FunctionsPackage.eNS_URI) : FunctionsPackage.eINSTANCE);
		ParameterdependenciesPackageImpl theParameterdependenciesPackage = (ParameterdependenciesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ParameterdependenciesPackage.eNS_URI) instanceof ParameterdependenciesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ParameterdependenciesPackage.eNS_URI) : ParameterdependenciesPackage.eINSTANCE);
		RepositoryPackageImpl theRepositoryPackage = (RepositoryPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI) instanceof RepositoryPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI) : RepositoryPackage.eINSTANCE);
		SystemPackageImpl theSystemPackage = (SystemPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SystemPackage.eNS_URI) instanceof SystemPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SystemPackage.eNS_URI) : SystemPackage.eINSTANCE);

		// Create package meta-data objects
		theServicebehaviorPackage.createPackageContents();
		theFunctionsPackage.createPackageContents();
		theParameterdependenciesPackage.createPackageContents();
		theRepositoryPackage.createPackageContents();
		theSystemPackage.createPackageContents();

		// Initialize created meta-data
		theServicebehaviorPackage.initializePackageContents();
		theFunctionsPackage.initializePackageContents();
		theParameterdependenciesPackage.initializePackageContents();
		theRepositoryPackage.initializePackageContents();
		theSystemPackage.initializePackageContents();

		// Register package validator
		EValidator.Registry.INSTANCE.put
			(theServicebehaviorPackage, 
			 new EValidator.Descriptor() {
				 public EValidator getEValidator() {
					 return ServicebehaviorValidator.INSTANCE;
				 }
			 });

		// Mark meta-data to indicate it can't be changed
		theServicebehaviorPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(ServicebehaviorPackage.eNS_URI, theServicebehaviorPackage);
		return theServicebehaviorPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getServiceBehaviorAbstraction() {
		return serviceBehaviorAbstractionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getServiceBehaviorAbstraction_DescribedSignature() {
		return (EReference)serviceBehaviorAbstractionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getServiceBehaviorAbstraction_InfluencingParameter() {
		return (EReference)serviceBehaviorAbstractionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getServiceBehaviorAbstraction_InfluencedVariableReference() {
		return (EReference)serviceBehaviorAbstractionEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getServiceBehaviorAbstraction_InterfaceProvidingRole() {
		return (EReference)serviceBehaviorAbstractionEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFineGrainedBehavior() {
		return fineGrainedBehaviorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFineGrainedBehavior_BasicComponent() {
		return (EReference)fineGrainedBehaviorEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFineGrainedBehavior_Behavior() {
		return (EReference)fineGrainedBehaviorEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getComponentInternalBehavior() {
		return componentInternalBehaviorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getComponentInternalBehavior_Actions() {
		return (EReference)componentInternalBehaviorEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAbstractAction() {
		return abstractActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAbstractAction_ParentBehavior() {
		return (EReference)abstractActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAcquireAction() {
		return acquireActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAcquireAction_Semaphore() {
		return (EReference)acquireActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getReleaseAction() {
		return releaseActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getReleaseAction_Semaphore() {
		return (EReference)releaseActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInternalAction() {
		return internalActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getInternalAction_ResourceDemand() {
		return (EReference)internalActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getForkAction() {
		return forkActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getForkAction_WithSynchronizationBarrier() {
		return (EAttribute)forkActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getForkAction_ForkedBehaviors() {
		return (EReference)forkActionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBranchAction() {
		return branchActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBranchAction_Branches() {
		return (EReference)branchActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBranchAction_BranchProbabilities() {
		return (EReference)branchActionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBranchProbabilities() {
		return branchProbabilitiesEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBranchProbabilities_BranchAction() {
		return (EReference)branchProbabilitiesEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLoopAction() {
		return loopActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLoopAction_LoopBodyBehavior() {
		return (EReference)loopActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLoopAction_LoopIterationCount() {
		return (EReference)loopActionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLoopIterationCount() {
		return loopIterationCountEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLoopIterationCount_LoopAction() {
		return (EReference)loopIterationCountEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getExternalCallAction() {
		return externalCallActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getExternalCallAction_ExternalCall() {
		return (EReference)externalCallActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getExternalCall() {
		return externalCallEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getExternalCall_Signature() {
		return (EReference)externalCallEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getExternalCall_InterfaceRequiringRole() {
		return (EReference)externalCallEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getResourceDemand() {
		return resourceDemandEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getResourceDemand_InternalAction() {
		return (EReference)resourceDemandEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getResourceDemand_CoarseGrainedBehavior() {
		return (EReference)resourceDemandEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getResourceDemand_ResourceType() {
		return (EReference)resourceDemandEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getResourceDemand_Characterization() {
		return (EAttribute)resourceDemandEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getResourceDemand_ExplicitDescription() {
		return (EReference)resourceDemandEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCoarseGrainedBehavior() {
		return coarseGrainedBehaviorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCoarseGrainedBehavior_DescribedEntity() {
		return (EReference)coarseGrainedBehaviorEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCoarseGrainedBehavior_ExternalCallFrequency() {
		return (EReference)coarseGrainedBehaviorEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCoarseGrainedBehavior_ResourceDemand() {
		return (EReference)coarseGrainedBehaviorEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getExternalCallFrequency() {
		return externalCallFrequencyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getExternalCallFrequency_CoarseGrainedBehavior() {
		return (EReference)externalCallFrequencyEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getExternalCallFrequency_ExternalCall() {
		return (EReference)externalCallFrequencyEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getExternalCallFrequency_Frequency() {
		return (EReference)externalCallFrequencyEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCallFrequency() {
		return callFrequencyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCallFrequency_ExternalCallFrequency() {
		return (EReference)callFrequencyEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBlackBoxBehavior() {
		return blackBoxBehaviorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBlackBoxBehavior_DescribedEntity() {
		return (EReference)blackBoxBehaviorEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBlackBoxBehavior_ResponseTime() {
		return (EReference)blackBoxBehaviorEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getResponseTime() {
		return responseTimeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getResponseTime_BlackBoxBehavior() {
		return (EReference)responseTimeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getResponseTime_Characterization() {
		return (EAttribute)responseTimeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getResponseTime_ExplicitDescription() {
		return (EReference)responseTimeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ServicebehaviorFactory getServicebehaviorFactory() {
		return (ServicebehaviorFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		serviceBehaviorAbstractionEClass = createEClass(SERVICE_BEHAVIOR_ABSTRACTION);
		createEReference(serviceBehaviorAbstractionEClass, SERVICE_BEHAVIOR_ABSTRACTION__DESCRIBED_SIGNATURE);
		createEReference(serviceBehaviorAbstractionEClass, SERVICE_BEHAVIOR_ABSTRACTION__INFLUENCING_PARAMETER);
		createEReference(serviceBehaviorAbstractionEClass, SERVICE_BEHAVIOR_ABSTRACTION__INFLUENCED_VARIABLE_REFERENCE);
		createEReference(serviceBehaviorAbstractionEClass, SERVICE_BEHAVIOR_ABSTRACTION__INTERFACE_PROVIDING_ROLE);

		fineGrainedBehaviorEClass = createEClass(FINE_GRAINED_BEHAVIOR);
		createEReference(fineGrainedBehaviorEClass, FINE_GRAINED_BEHAVIOR__BASIC_COMPONENT);
		createEReference(fineGrainedBehaviorEClass, FINE_GRAINED_BEHAVIOR__BEHAVIOR);

		componentInternalBehaviorEClass = createEClass(COMPONENT_INTERNAL_BEHAVIOR);
		createEReference(componentInternalBehaviorEClass, COMPONENT_INTERNAL_BEHAVIOR__ACTIONS);

		abstractActionEClass = createEClass(ABSTRACT_ACTION);
		createEReference(abstractActionEClass, ABSTRACT_ACTION__PARENT_BEHAVIOR);

		acquireActionEClass = createEClass(ACQUIRE_ACTION);
		createEReference(acquireActionEClass, ACQUIRE_ACTION__SEMAPHORE);

		releaseActionEClass = createEClass(RELEASE_ACTION);
		createEReference(releaseActionEClass, RELEASE_ACTION__SEMAPHORE);

		internalActionEClass = createEClass(INTERNAL_ACTION);
		createEReference(internalActionEClass, INTERNAL_ACTION__RESOURCE_DEMAND);

		forkActionEClass = createEClass(FORK_ACTION);
		createEAttribute(forkActionEClass, FORK_ACTION__WITH_SYNCHRONIZATION_BARRIER);
		createEReference(forkActionEClass, FORK_ACTION__FORKED_BEHAVIORS);

		branchActionEClass = createEClass(BRANCH_ACTION);
		createEReference(branchActionEClass, BRANCH_ACTION__BRANCHES);
		createEReference(branchActionEClass, BRANCH_ACTION__BRANCH_PROBABILITIES);

		branchProbabilitiesEClass = createEClass(BRANCH_PROBABILITIES);
		createEReference(branchProbabilitiesEClass, BRANCH_PROBABILITIES__BRANCH_ACTION);

		loopActionEClass = createEClass(LOOP_ACTION);
		createEReference(loopActionEClass, LOOP_ACTION__LOOP_BODY_BEHAVIOR);
		createEReference(loopActionEClass, LOOP_ACTION__LOOP_ITERATION_COUNT);

		loopIterationCountEClass = createEClass(LOOP_ITERATION_COUNT);
		createEReference(loopIterationCountEClass, LOOP_ITERATION_COUNT__LOOP_ACTION);

		externalCallActionEClass = createEClass(EXTERNAL_CALL_ACTION);
		createEReference(externalCallActionEClass, EXTERNAL_CALL_ACTION__EXTERNAL_CALL);

		externalCallEClass = createEClass(EXTERNAL_CALL);
		createEReference(externalCallEClass, EXTERNAL_CALL__SIGNATURE);
		createEReference(externalCallEClass, EXTERNAL_CALL__INTERFACE_REQUIRING_ROLE);

		resourceDemandEClass = createEClass(RESOURCE_DEMAND);
		createEReference(resourceDemandEClass, RESOURCE_DEMAND__INTERNAL_ACTION);
		createEReference(resourceDemandEClass, RESOURCE_DEMAND__COARSE_GRAINED_BEHAVIOR);
		createEReference(resourceDemandEClass, RESOURCE_DEMAND__RESOURCE_TYPE);
		createEAttribute(resourceDemandEClass, RESOURCE_DEMAND__CHARACTERIZATION);
		createEReference(resourceDemandEClass, RESOURCE_DEMAND__EXPLICIT_DESCRIPTION);

		coarseGrainedBehaviorEClass = createEClass(COARSE_GRAINED_BEHAVIOR);
		createEReference(coarseGrainedBehaviorEClass, COARSE_GRAINED_BEHAVIOR__DESCRIBED_ENTITY);
		createEReference(coarseGrainedBehaviorEClass, COARSE_GRAINED_BEHAVIOR__EXTERNAL_CALL_FREQUENCY);
		createEReference(coarseGrainedBehaviorEClass, COARSE_GRAINED_BEHAVIOR__RESOURCE_DEMAND);

		externalCallFrequencyEClass = createEClass(EXTERNAL_CALL_FREQUENCY);
		createEReference(externalCallFrequencyEClass, EXTERNAL_CALL_FREQUENCY__COARSE_GRAINED_BEHAVIOR);
		createEReference(externalCallFrequencyEClass, EXTERNAL_CALL_FREQUENCY__EXTERNAL_CALL);
		createEReference(externalCallFrequencyEClass, EXTERNAL_CALL_FREQUENCY__FREQUENCY);

		callFrequencyEClass = createEClass(CALL_FREQUENCY);
		createEReference(callFrequencyEClass, CALL_FREQUENCY__EXTERNAL_CALL_FREQUENCY);

		blackBoxBehaviorEClass = createEClass(BLACK_BOX_BEHAVIOR);
		createEReference(blackBoxBehaviorEClass, BLACK_BOX_BEHAVIOR__DESCRIBED_ENTITY);
		createEReference(blackBoxBehaviorEClass, BLACK_BOX_BEHAVIOR__RESPONSE_TIME);

		responseTimeEClass = createEClass(RESPONSE_TIME);
		createEReference(responseTimeEClass, RESPONSE_TIME__BLACK_BOX_BEHAVIOR);
		createEAttribute(responseTimeEClass, RESPONSE_TIME__CHARACTERIZATION);
		createEReference(responseTimeEClass, RESPONSE_TIME__EXPLICIT_DESCRIPTION);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		RepositoryPackage theRepositoryPackage = (RepositoryPackage)EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI);
		ParameterdependenciesPackage theParameterdependenciesPackage = (ParameterdependenciesPackage)EPackage.Registry.INSTANCE.getEPackage(ParameterdependenciesPackage.eNS_URI);
		ResourcetypePackage theResourcetypePackage = (ResourcetypePackage)EPackage.Registry.INSTANCE.getEPackage(ResourcetypePackage.eNS_URI);
		FunctionsPackage theFunctionsPackage = (FunctionsPackage)EPackage.Registry.INSTANCE.getEPackage(FunctionsPackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		fineGrainedBehaviorEClass.getESuperTypes().add(this.getServiceBehaviorAbstraction());
		acquireActionEClass.getESuperTypes().add(this.getAbstractAction());
		releaseActionEClass.getESuperTypes().add(this.getAbstractAction());
		internalActionEClass.getESuperTypes().add(this.getAbstractAction());
		forkActionEClass.getESuperTypes().add(this.getAbstractAction());
		branchActionEClass.getESuperTypes().add(this.getAbstractAction());
		branchProbabilitiesEClass.getESuperTypes().add(theParameterdependenciesPackage.getControlFlowVariable());
		loopActionEClass.getESuperTypes().add(this.getAbstractAction());
		loopIterationCountEClass.getESuperTypes().add(theParameterdependenciesPackage.getControlFlowVariable());
		externalCallActionEClass.getESuperTypes().add(this.getAbstractAction());
		resourceDemandEClass.getESuperTypes().add(theParameterdependenciesPackage.getModelVariable());
		coarseGrainedBehaviorEClass.getESuperTypes().add(this.getServiceBehaviorAbstraction());
		callFrequencyEClass.getESuperTypes().add(theParameterdependenciesPackage.getControlFlowVariable());
		blackBoxBehaviorEClass.getESuperTypes().add(this.getServiceBehaviorAbstraction());
		responseTimeEClass.getESuperTypes().add(theParameterdependenciesPackage.getModelVariable());

		// Initialize classes and features; add operations and parameters
		initEClass(serviceBehaviorAbstractionEClass, ServiceBehaviorAbstraction.class, "ServiceBehaviorAbstraction", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getServiceBehaviorAbstraction_DescribedSignature(), theRepositoryPackage.getSignature(), null, "describedSignature", null, 0, 1, ServiceBehaviorAbstraction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getServiceBehaviorAbstraction_InfluencingParameter(), theParameterdependenciesPackage.getInfluencingParameter(), null, "influencingParameter", null, 0, -1, ServiceBehaviorAbstraction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getServiceBehaviorAbstraction_InfluencedVariableReference(), theParameterdependenciesPackage.getInfluencedVariableReference(), null, "influencedVariableReference", null, 0, -1, ServiceBehaviorAbstraction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getServiceBehaviorAbstraction_InterfaceProvidingRole(), theRepositoryPackage.getInterfaceProvidingRole(), null, "interfaceProvidingRole", null, 0, 1, ServiceBehaviorAbstraction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(fineGrainedBehaviorEClass, FineGrainedBehavior.class, "FineGrainedBehavior", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getFineGrainedBehavior_BasicComponent(), theRepositoryPackage.getBasicComponent(), null, "basicComponent", null, 1, 1, FineGrainedBehavior.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getFineGrainedBehavior_Behavior(), this.getComponentInternalBehavior(), null, "behavior", null, 1, 1, FineGrainedBehavior.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(componentInternalBehaviorEClass, ComponentInternalBehavior.class, "ComponentInternalBehavior", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getComponentInternalBehavior_Actions(), this.getAbstractAction(), this.getAbstractAction_ParentBehavior(), "actions", null, 0, -1, ComponentInternalBehavior.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(abstractActionEClass, AbstractAction.class, "AbstractAction", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAbstractAction_ParentBehavior(), this.getComponentInternalBehavior(), this.getComponentInternalBehavior_Actions(), "parentBehavior", null, 1, 1, AbstractAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(acquireActionEClass, AcquireAction.class, "AcquireAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAcquireAction_Semaphore(), theRepositoryPackage.getSemaphore(), null, "semaphore", null, 1, 1, AcquireAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(releaseActionEClass, ReleaseAction.class, "ReleaseAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getReleaseAction_Semaphore(), theRepositoryPackage.getSemaphore(), null, "semaphore", null, 1, 1, ReleaseAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(internalActionEClass, InternalAction.class, "InternalAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getInternalAction_ResourceDemand(), this.getResourceDemand(), this.getResourceDemand_InternalAction(), "resourceDemand", null, 0, -1, InternalAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(forkActionEClass, ForkAction.class, "ForkAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getForkAction_WithSynchronizationBarrier(), ecorePackage.getEBoolean(), "withSynchronizationBarrier", null, 1, 1, ForkAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getForkAction_ForkedBehaviors(), this.getComponentInternalBehavior(), null, "forkedBehaviors", null, 0, -1, ForkAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(branchActionEClass, BranchAction.class, "BranchAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBranchAction_Branches(), this.getComponentInternalBehavior(), null, "branches", null, 0, -1, BranchAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBranchAction_BranchProbabilities(), this.getBranchProbabilities(), this.getBranchProbabilities_BranchAction(), "branchProbabilities", null, 1, 1, BranchAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(branchProbabilitiesEClass, BranchProbabilities.class, "BranchProbabilities", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBranchProbabilities_BranchAction(), this.getBranchAction(), this.getBranchAction_BranchProbabilities(), "branchAction", null, 1, 1, BranchProbabilities.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(loopActionEClass, LoopAction.class, "LoopAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getLoopAction_LoopBodyBehavior(), this.getComponentInternalBehavior(), null, "loopBodyBehavior", null, 1, 1, LoopAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getLoopAction_LoopIterationCount(), this.getLoopIterationCount(), this.getLoopIterationCount_LoopAction(), "loopIterationCount", null, 1, 1, LoopAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(loopIterationCountEClass, LoopIterationCount.class, "LoopIterationCount", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getLoopIterationCount_LoopAction(), this.getLoopAction(), this.getLoopAction_LoopIterationCount(), "loopAction", null, 1, 1, LoopIterationCount.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(externalCallActionEClass, ExternalCallAction.class, "ExternalCallAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getExternalCallAction_ExternalCall(), this.getExternalCall(), null, "externalCall", null, 1, 1, ExternalCallAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(externalCallEClass, ExternalCall.class, "ExternalCall", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getExternalCall_Signature(), theRepositoryPackage.getSignature(), null, "signature", null, 1, 1, ExternalCall.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getExternalCall_InterfaceRequiringRole(), theRepositoryPackage.getInterfaceRequiringRole(), null, "interfaceRequiringRole", null, 1, 1, ExternalCall.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(resourceDemandEClass, ResourceDemand.class, "ResourceDemand", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getResourceDemand_InternalAction(), this.getInternalAction(), this.getInternalAction_ResourceDemand(), "internalAction", null, 0, 1, ResourceDemand.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getResourceDemand_CoarseGrainedBehavior(), this.getCoarseGrainedBehavior(), this.getCoarseGrainedBehavior_ResourceDemand(), "coarseGrainedBehavior", null, 0, 1, ResourceDemand.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getResourceDemand_ResourceType(), theResourcetypePackage.getResourceType(), null, "resourceType", null, 1, 1, ResourceDemand.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getResourceDemand_Characterization(), theParameterdependenciesPackage.getModelVariableCharacterizationType(), "characterization", null, 1, 1, ResourceDemand.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getResourceDemand_ExplicitDescription(), theFunctionsPackage.getExplicitDescription(), null, "explicitDescription", null, 0, 1, ResourceDemand.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(coarseGrainedBehaviorEClass, CoarseGrainedBehavior.class, "CoarseGrainedBehavior", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getCoarseGrainedBehavior_DescribedEntity(), theRepositoryPackage.getInterfaceProvidingRequiringEntity(), null, "describedEntity", null, 1, 1, CoarseGrainedBehavior.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCoarseGrainedBehavior_ExternalCallFrequency(), this.getExternalCallFrequency(), this.getExternalCallFrequency_CoarseGrainedBehavior(), "externalCallFrequency", null, 0, -1, CoarseGrainedBehavior.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getCoarseGrainedBehavior_ResourceDemand(), this.getResourceDemand(), this.getResourceDemand_CoarseGrainedBehavior(), "resourceDemand", null, 0, -1, CoarseGrainedBehavior.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(externalCallFrequencyEClass, ExternalCallFrequency.class, "ExternalCallFrequency", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getExternalCallFrequency_CoarseGrainedBehavior(), this.getCoarseGrainedBehavior(), this.getCoarseGrainedBehavior_ExternalCallFrequency(), "coarseGrainedBehavior", null, 1, 1, ExternalCallFrequency.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getExternalCallFrequency_ExternalCall(), this.getExternalCall(), null, "externalCall", null, 1, 1, ExternalCallFrequency.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getExternalCallFrequency_Frequency(), this.getCallFrequency(), this.getCallFrequency_ExternalCallFrequency(), "frequency", null, 1, 1, ExternalCallFrequency.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(callFrequencyEClass, CallFrequency.class, "CallFrequency", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getCallFrequency_ExternalCallFrequency(), this.getExternalCallFrequency(), this.getExternalCallFrequency_Frequency(), "externalCallFrequency", null, 1, 1, CallFrequency.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(blackBoxBehaviorEClass, BlackBoxBehavior.class, "BlackBoxBehavior", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBlackBoxBehavior_DescribedEntity(), theRepositoryPackage.getInterfaceProvidingEntity(), null, "describedEntity", null, 1, 1, BlackBoxBehavior.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBlackBoxBehavior_ResponseTime(), this.getResponseTime(), this.getResponseTime_BlackBoxBehavior(), "responseTime", null, 0, 1, BlackBoxBehavior.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(responseTimeEClass, ResponseTime.class, "ResponseTime", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getResponseTime_BlackBoxBehavior(), this.getBlackBoxBehavior(), this.getBlackBoxBehavior_ResponseTime(), "blackBoxBehavior", null, 1, 1, ResponseTime.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getResponseTime_Characterization(), theParameterdependenciesPackage.getModelVariableCharacterizationType(), "characterization", null, 1, 1, ResponseTime.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getResponseTime_ExplicitDescription(), theFunctionsPackage.getExplicitDescription(), null, "explicitDescription", null, 0, 1, ResponseTime.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Create resource
		createResource(eNS_URI);

		// Create annotations
		// http://www.eclipse.org/OCL/Import
		createImportAnnotations();
		// http://www.eclipse.org/emf/2002/Ecore
		createEcoreAnnotations();
		// http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot
		createPivotAnnotations();
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/OCL/Import</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createImportAnnotations() {
		String source = "http://www.eclipse.org/OCL/Import";	
		addAnnotation
		  (this, 
		   source, 
		   new String[] {
			 "core_0", "../../edu.kit.ipd.descartes.core/model/core.ecore#/",
			 "ecore_0", "http://www.eclipse.org/emf/2002/Ecore",
			 "functions_0", "functions.ecore#/",
			 "parameterdependencies", "parameterdependency.ecore#/",
			 "repository_0", "repository.ecore#/",
			 "resourcetype_0", "../../edu.kit.ipd.descartes.mm.resourcelandscape/model/resourcetype.ecore#/"
		   });
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createEcoreAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/Ecore";	
		addAnnotation
		  (this, 
		   source, 
		   new String[] {
			 "invocationDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
			 "settingDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
			 "validationDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot"
		   });	
		addAnnotation
		  (serviceBehaviorAbstractionEClass, 
		   source, 
		   new String[] {
			 "constraints", "DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole InfluencingParameterNamesMustBeUnique"
		   });	
		addAnnotation
		  (fineGrainedBehaviorEClass, 
		   source, 
		   new String[] {
			 "constraints", "ReferencedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole AtMostOneFineGrainedBehaviorPerProvidedService"
		   });	
		addAnnotation
		  (externalCallEClass, 
		   source, 
		   new String[] {
			 "constraints", "SignatureBelongsToInterfaceRequiringRole"
		   });	
		addAnnotation
		  (resourceDemandEClass, 
		   source, 
		   new String[] {
			 "constraints", "EnforceExplicitDescriptionWhenExplicitCharacterizationType"
		   });	
		addAnnotation
		  (coarseGrainedBehaviorEClass, 
		   source, 
		   new String[] {
			 "constraints", "AtMostOneCoarseGrainedBehaviorPerProvidedService"
		   });	
		addAnnotation
		  (blackBoxBehaviorEClass, 
		   source, 
		   new String[] {
			 "constraints", "AtMostOneBlackBoxBehaviorPerProvidedService"
		   });	
		addAnnotation
		  (responseTimeEClass, 
		   source, 
		   new String[] {
			 "constraints", "EnforceExplicitDescriptionWhenExplicitCharacterizationType"
		   });
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createPivotAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot";	
		addAnnotation
		  (serviceBehaviorAbstractionEClass, 
		   source, 
		   new String[] {
			 "DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole", "\n\t\t\tself.interfaceProvidingRole.interface.signatures->exists(sign|sign=self.describedSignature)",
			 "InfluencingParameterNamesMustBeUnique", "\n\t\t\tself.influencingParameter->select(inflp | inflp.oclIsKindOf(parameterdependencies::ShadowParameter))\n\t\t\t\t\t\t\t\t\t ->collect(inflp | inflp.oclAsType(parameterdependencies::ShadowParameter))\n\t\t\t\t\t\t\t\t\t ->isUnique(inflp | inflp.name)"
		   });	
		addAnnotation
		  (fineGrainedBehaviorEClass, 
		   source, 
		   new String[] {
			 "ReferencedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole", "\n\t\t\tself.basicComponent.interfaceProvidingRoles->exists(p | p.interface = self.describedSignature.interface)",
			 "AtMostOneFineGrainedBehaviorPerProvidedService", "\n\t\t\tself.basicComponent.fineGrainedBehavior->forAll(fgb1 : FineGrainedBehavior | fgb1.describedSignature = self.describedSignature implies fgb1 = self)"
		   });	
		addAnnotation
		  (externalCallEClass, 
		   source, 
		   new String[] {
			 "SignatureBelongsToInterfaceRequiringRole", "\n\t\t\tself.interfaceRequiringRole.interface.signatures->includes(self.signature)"
		   });	
		addAnnotation
		  (resourceDemandEClass, 
		   source, 
		   new String[] {
			 "EnforceExplicitDescriptionWhenExplicitCharacterizationType", "\n\t\t   self.characterization = parameterdependencies::RelationshipCharacterizationType::EXPLICIT implies explicitDescription <> null"
		   });	
		addAnnotation
		  (coarseGrainedBehaviorEClass, 
		   source, 
		   new String[] {
			 "AtMostOneCoarseGrainedBehaviorPerProvidedService", "\n\t\t\tself.describedEntity.coarseGrainedBehavior->forAll(cgb1 : CoarseGrainedBehavior | cgb1.describedSignature = self.describedSignature implies cgb1 = self)"
		   });	
		addAnnotation
		  (blackBoxBehaviorEClass, 
		   source, 
		   new String[] {
			 "AtMostOneBlackBoxBehaviorPerProvidedService", "\n\t\t\tself.describedEntity.blackBoxBehavior->forAll(bb1 : BlackBoxBehavior | bb1.describedSignature = self.describedSignature implies bb1 = self)"
		   });	
		addAnnotation
		  (responseTimeEClass, 
		   source, 
		   new String[] {
			 "EnforceExplicitDescriptionWhenExplicitCharacterizationType", "\n\t\t\tself.characterization = parameterdependencies::RelationshipCharacterizationType::EXPLICIT implies explicitDescription <> null"
		   });
	}

} //ServicebehaviorPackageImpl
